package cn.com.qmth.examcloud.exchange.inner.api.provider;

import cn.com.qmth.examcloud.exchange.inner.api.SmsCloudService;
import cn.com.qmth.examcloud.exchange.inner.api.request.CheckSmsCodeReq;
import cn.com.qmth.examcloud.exchange.inner.api.request.SendSmsCodeReq;
import cn.com.qmth.examcloud.exchange.inner.api.request.SendSmsReq;
import cn.com.qmth.examcloud.exchange.inner.api.response.CheckSmsCodeResp;
import cn.com.qmth.examcloud.exchange.inner.api.response.SendSmsCodeResp;
import cn.com.qmth.examcloud.exchange.inner.api.response.SendSmsResp;
import cn.com.qmth.examcloud.exchange.inner.service.SmsService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import cn.com.qmth.examcloud.web.support.WithoutStackTrace;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

/**
 * 短信发送
 */
@RestController
@RequestMapping("${$rmp.cloud.exchange.inner}" + "/sms")
public class SmsCloudServiceProvider extends ControllerSupport implements SmsCloudService {

    private static final long serialVersionUID = -1497756895732370672L;

    @Autowired
    private SmsService smsService;

    @Override
    @RequestMapping(method = RequestMethod.POST, value = "sendSms")
    public SendSmsResp sendSms(@RequestBody @Valid @ApiParam(required = true) SendSmsReq req) {
        smsService.sendSms(req.getSmsAssemblyCode(), req.getPhoneList(), req.getParams());
        return new SendSmsResp();
    }

    @Override
    @WithoutStackTrace
    @RequestMapping(method = RequestMethod.POST, value = "sendSmsCode")
    public SendSmsCodeResp sendSmsCode(@RequestBody @Valid @ApiParam(required = true) SendSmsCodeReq req) {
        smsService.sendSmsCode(req.getPhone(), req.getCode());
        return new SendSmsCodeResp();
    }

    @Override
    @WithoutStackTrace
    @RequestMapping(method = RequestMethod.POST, value = "checkSmsCode")
    public CheckSmsCodeResp checkSmsCode(@RequestBody @Valid @ApiParam(required = true) CheckSmsCodeReq req) {
        smsService.validateSmsCode(req.getPhone(), req.getCode());
        return new CheckSmsCodeResp();
    }

}
